package uy.gub.imm;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

import org.apache.log4j.Logger;
import org.jboss.ejb3.annotation.ResourceAdapter;

@MessageDriven(name = "AuthenticatedMessage", activationConfig = { 
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/hornet")
		}, mappedName = "ConnectionFactory")


@ResourceAdapter("hornetq-ra.rar")
public class MessageBean implements MessageListener {
	private static Logger log = Logger.getLogger(MessageBean.class);
	
    public MessageBean() {
    }
	
    public void onMessage(Message message) {
    	try {
			log.info("---------> Message: " + ((TextMessage)message).getText());
			log.info("---------> User id: " + ((TextMessage)message).getStringProperty("user_id"));
		} catch (JMSException e) {
			e.printStackTrace();
		}
    }

}
