package uy.gub.imm;

import javax.annotation.Resource;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.apache.log4j.Logger;

@Stateless
public class ServicesBean implements ServicesBeanLocal {
	@Resource(mappedName="ConnectionFactory")
	private ConnectionFactory connectionFactory;
	@Resource(mappedName="queue/hornet")
	private Queue queue;
	@Resource
	private SessionContext sctx;
	private static Logger log = Logger.getLogger(ServicesBean.class);
	
    public ServicesBean() {
    }

	@Override
	public void sendMessage(String strMessage) {
		Connection connection = null;
		
		try {
			log.info("EJB user: " + sctx.getCallerPrincipal());
			
			connection = connectionFactory.createConnection();
			Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
			MessageProducer producer = session.createProducer(queue);
			TextMessage message = session.createTextMessage();
			message.setText(strMessage);
			
			producer.send(message);
		} catch (JMSException e) {
			e.printStackTrace();
		} finally{
			if (connection != null){
				try {connection.close();} catch (JMSException e1){}
			}
		}
	}

}
